//****************************************************************************
// Copyright (C) 2001,2002,2003  PEAK System-Technik GmbH
//
// linux@peak-system.com
// www.peak-system.com
//
// This part of software is proprietary 
// No warranty is given at all
//
// Maintainer(s): Klaus Hitschler (klaus.hitschler@gmx.de)
//****************************************************************************

//****************************************************************************
//
// pcan_usb-kernel.c - the inner hidden usb parts for pcan-usb support
//
// $Log: pcan_usb_kernel.c,v $
// Revision 1.7  2004/03/04 19:43:55  klaus
// wrong handling of RTR data contents - really -removed
//
// Revision 1.6  2004/03/04 18:50:41  klaus
// wrong handling of RTR data contents removed
//
// Revision 1.5  2003/03/02 12:18:33  klaus
// Release_20030302_?
//
// Revision 1.4  2003/03/02 12:18:33  klaus
// Release_20030302_?
//
// Revision 1.3  2003/03/02 11:09:21  klaus
// removed software distribution limitation in header
//
// Revision 1.2  2003/03/02 10:46:31  klaus
// merged USB thread into main path
//
// Revision 1.1.2.34  2003/02/24 19:13:01  klaus
// another try with obfuscation
//
// Revision 1.1.2.33  2003/02/24 18:39:16  klaus
// removed Makefile inconsistency
//
// Revision 1.1.2.32  2003/02/23 19:32:10  klaus
// fixed system macro strangeness in cobf processing
//
// Revision 1.1.2.31  2003/02/22 18:19:24  klaus
// small changes
//
// Revision 1.1.2.29  2003/02/22 18:00:08  klaus
// pcan_usb_kernel.c inherits its header from predecessor
//
//****************************************************************************

/* COBF by BB -- obfuscated at Thu Mar  4 20:40:07 2004
*/
#include<src/pcan_common.h>
#include<pcan.h>
#include<src/pcan_fifo.h>
#include<src/pcan_usb_kernel.h>
#include"cobf.h"
pcan_l91 pcan_l168{pcan_c pcan_j[4];pcan_l42 pcan_l40;}pcan_l116;
pcan_l91 pcan_l168{pcan_c pcan_j[2];pcan_l43 pcan_l95;}pcan_l154;
pcan_l91 pcan_n{pcan_c pcan_l73;pcan_c pcan_l57;pcan_c pcan_l126;
pcan_c pcan_l125;pcan_c pcan_l124;pcan_c pcan_l102;pcan_c pcan_l122;
pcan_c pcan_l101;pcan_c pcan_l103;pcan_c pcan_l119;pcan_c pcan_l167;
pcan_c pcan_l166;pcan_c pcan_l137;pcan_c pcan_l136;pcan_c pcan_l135;
pcan_c pcan_l134;}__attribute__((packed))pcan_l86;pcan_l91 pcan_n{
pcan_l108 pcan_l31;pcan_l108 pcan_l69;pcan_l42 pcan_l63;pcan_l43
pcan_l89;pcan_l43 pcan_l39;pcan_l43 pcan_l65;pcan_c pcan_l59;}
pcan_l33;pcan_l29 pcan_l47 pcan_l140(pcan_n pcan_p*pcan_b){pcan_l33*
pcan_h=(pcan_l33* )pcan_b->pcan_m.pcan_l.pcan_l58;pcan_s(pcan_t"\x25"
"\x73\x3a\x20\x72\x65\x73\x65\x74\x5f\x74\x69\x6d\x65\x73\x74\x61\x6d"
"\x70\x28\x29\n",pcan_o);pcan_h->pcan_l31=0;pcan_h->pcan_l69=0;pcan_h
->pcan_l39=0;pcan_h->pcan_l59=0;pcan_h->pcan_l65=0;pcan_h->pcan_l63=0
;pcan_h->pcan_l89=0;}pcan_l29 pcan_l141 pcan_l42 pcan_l149(pcan_n
pcan_p*pcan_b){pcan_l54 pcan_l33*pcan_h=(pcan_l33* )pcan_b->pcan_m.
pcan_l.pcan_l58;pcan_l108 pcan_l70;pcan_l70=pcan_h->pcan_l31-pcan_h->
pcan_l89;pcan_l70*=44739;pcan_l70>>=20;pcan_q(pcan_l42)pcan_l70;}
pcan_l29 pcan_l141 pcan_l42 pcan_l129(pcan_n pcan_p*pcan_b){pcan_q((
pcan_l33* )pcan_b->pcan_m.pcan_l.pcan_l58)->pcan_l63+pcan_l149(pcan_b
);}pcan_l29 pcan_l47 pcan_l82(pcan_n pcan_p*pcan_b,pcan_l43 pcan_r,
pcan_c pcan_l164){pcan_l54 pcan_l33*pcan_h=(pcan_l33* )pcan_b->pcan_m
.pcan_l.pcan_l58;pcan_f(!pcan_h->pcan_l63){pcan_h->pcan_l63=pcan_l193
 * (1000/pcan_l90)- *pcan_b->pcan_l204;pcan_h->pcan_l89=pcan_r;pcan_h
->pcan_l65=pcan_r;pcan_h->pcan_l31=pcan_r;pcan_h->pcan_l69=pcan_r;}
pcan_f(pcan_l164){pcan_h->pcan_l31=pcan_h->pcan_l69;pcan_h->pcan_l39=
pcan_h->pcan_l65;}pcan_h->pcan_l69=pcan_h->pcan_l31;pcan_h->pcan_l65=
pcan_h->pcan_l39;pcan_f(pcan_r<pcan_h->pcan_l39)pcan_h->pcan_l31+=
0x10000LL;pcan_h->pcan_l31&=~0xFFFFLL;pcan_h->pcan_l31|=pcan_r;pcan_h
->pcan_l39=pcan_r;pcan_h->pcan_l59=(pcan_c)(pcan_r&0xff);}pcan_l29
pcan_l47 pcan_l104(pcan_n pcan_p*pcan_b,pcan_c pcan_l61){pcan_l54
pcan_l33*pcan_h=(pcan_l33* )pcan_b->pcan_m.pcan_l.pcan_l58;pcan_f(
pcan_l61<pcan_h->pcan_l59){pcan_h->pcan_l31+=0x100;pcan_h->pcan_l39+=
0x100;}pcan_h->pcan_l31&=~0xFFLL;pcan_h->pcan_l31|=pcan_l61;pcan_h->
pcan_l39&=~0xFF;pcan_h->pcan_l39|=pcan_l61;pcan_h->pcan_l59=pcan_l61;
}pcan_e pcan_X(pcan_l47){pcan_q pcan_l62(pcan_l33);}pcan_l29 pcan_l47
pcan_l87(pcan_l93 pcan_l153){pcan_n pcan_p*pcan_b=pcan_l153->
pcan_l186;pcan_l203(1,&pcan_b->pcan_m.pcan_l.pcan_l78);pcan_l84(&
pcan_b->pcan_m.pcan_l.pcan_l46,1);}pcan_l29 pcan_e pcan_l37(pcan_n
pcan_p*pcan_b,pcan_c pcan_l44,pcan_c pcan_l45,pcan_c pcan_l32,pcan_c
pcan_l38,pcan_c pcan_l80,pcan_c pcan_l92,pcan_c pcan_l77,pcan_c
pcan_l99,pcan_c pcan_l75,pcan_c pcan_l76,pcan_c pcan_l133,pcan_c
pcan_l132,pcan_c pcan_l160,pcan_c pcan_l165,pcan_c pcan_l163,pcan_c
pcan_l162){pcan_l86 pcan_i;pcan_e pcan_l28=0;pcan_l54 pcan_l93 pcan_v
;pcan_f(!pcan_b->pcan_l150)pcan_q-pcan_l157;pcan_i.pcan_l73=pcan_l44;
pcan_i.pcan_l57=pcan_l45;pcan_i.pcan_l126=pcan_l32;pcan_i.pcan_l125=
pcan_l38;pcan_i.pcan_l124=pcan_l80;pcan_i.pcan_l102=pcan_l92;pcan_i.
pcan_l122=pcan_l77;pcan_i.pcan_l101=pcan_l99;pcan_i.pcan_l103=
pcan_l75;pcan_i.pcan_l119=pcan_l76;pcan_i.pcan_l167=pcan_l133;pcan_i.
pcan_l166=pcan_l132;pcan_i.pcan_l137=pcan_l160;pcan_i.pcan_l136=
pcan_l165;pcan_i.pcan_l135=pcan_l163;pcan_i.pcan_l134=pcan_l162;
pcan_v=pcan_b->pcan_m.pcan_l.pcan_l100;pcan_l110(pcan_v,pcan_b->
pcan_m.pcan_l.pcan_l52,pcan_l144(pcan_b->pcan_m.pcan_l.pcan_l52,
pcan_b->pcan_m.pcan_l.pcan_l111[1].pcan_l27),&pcan_i,pcan_l62(pcan_i),
pcan_l87,pcan_b);pcan_v->pcan_l128=((1000*pcan_l90)/1000);pcan_f(
pcan_l105(pcan_v)){pcan_s(pcan_l60"\x25\x73\x3a\x20\x70\x63\x61\x6e"
"\x5f\x73\x65\x74\x5f\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x28\x29\x20"
"\x63\x61\x6e\x27\x74\x20\x73\x75\x62\x6d\x69\x74\x21\n",pcan_o);
pcan_l28=pcan_v->pcan_l48;pcan_l34 pcan_z;}pcan_l26 pcan_l113(1,&
pcan_b->pcan_m.pcan_l.pcan_l78);pcan_l41(!pcan_l120(&pcan_b->pcan_m.
pcan_l.pcan_l46))pcan_l107();pcan_l28=pcan_v->pcan_l48;pcan_z:
pcan_l84(&pcan_b->pcan_m.pcan_l.pcan_l46,0);pcan_q pcan_l28;}pcan_l29
pcan_e pcan_l152(pcan_n pcan_p*pcan_b,pcan_c pcan_l44,pcan_c pcan_l45
){pcan_l86 pcan_i;pcan_e pcan_l28=0;pcan_l54 pcan_l93 pcan_v;pcan_i.
pcan_l73=pcan_l44;pcan_i.pcan_l57=pcan_l45;pcan_v=pcan_b->pcan_m.
pcan_l.pcan_l100;pcan_l110(pcan_v,pcan_b->pcan_m.pcan_l.pcan_l52,
pcan_l144(pcan_b->pcan_m.pcan_l.pcan_l52,pcan_b->pcan_m.pcan_l.
pcan_l111[1].pcan_l27),&pcan_i,pcan_l62(pcan_i.pcan_l73)+pcan_l62(
pcan_i.pcan_l57),pcan_l87,pcan_b);pcan_v->pcan_l128=((1000*pcan_l90)/
1000);pcan_f(pcan_l105(pcan_v)){pcan_l97(pcan_l60"\x25\x73\x3a\x20"
"\x70\x63\x61\x6e\x5f\x73\x65\x74\x5f\x66\x75\x6e\x63\x74\x69\x6f\x6e"
"\x28\x29\x20\x63\x61\x6e\x27\x74\x20\x73\x75\x62\x6d\x69\x74\x21\n",
pcan_o);pcan_l28=pcan_v->pcan_l48;pcan_l34 pcan_z;}pcan_l26 pcan_l113
(1,&pcan_b->pcan_m.pcan_l.pcan_l78);pcan_l41(!pcan_l120(&pcan_b->
pcan_m.pcan_l.pcan_l46))pcan_l107();pcan_l28=pcan_v->pcan_l48;pcan_z:
pcan_l84(&pcan_b->pcan_m.pcan_l.pcan_l46,0);pcan_q pcan_l28;}pcan_l29
pcan_e pcan_l56(pcan_n pcan_p*pcan_b,pcan_c pcan_l44,pcan_c pcan_l45,
pcan_c*pcan_l32,pcan_c*pcan_l38,pcan_c*pcan_l80,pcan_c*pcan_l92,
pcan_c*pcan_l77,pcan_c*pcan_l99,pcan_c*pcan_l75,pcan_c*pcan_l76){
pcan_l86 pcan_i;pcan_e pcan_l28=0;pcan_l54 pcan_l93 pcan_v;pcan_f(!
pcan_b->pcan_l150)pcan_q-pcan_l157;pcan_l28=pcan_l152(pcan_b,pcan_l44
,pcan_l45);pcan_l173(5);pcan_f(!pcan_l28){pcan_v=pcan_b->pcan_m.
pcan_l.pcan_l100;pcan_l110(pcan_v,pcan_b->pcan_m.pcan_l.pcan_l52,
pcan_l191(pcan_b->pcan_m.pcan_l.pcan_l52,pcan_b->pcan_m.pcan_l.
pcan_l111[0].pcan_l27),&pcan_i,pcan_l62(pcan_i),pcan_l87,pcan_b);
pcan_v->pcan_l128=((1000*pcan_l90)/1000);pcan_i.pcan_l73=pcan_l44;
pcan_i.pcan_l57=pcan_l45;pcan_f(pcan_l105(pcan_v)){pcan_l97(pcan_l60""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x67\x65\x74\x5f\x70\x61\x72\x61"
"\x6d\x65\x74\x65\x72\x28\x29\x20\x63\x61\x6e\x27\x74\x20\x73\x75\x62"
"\x6d\x69\x74\x21\n",pcan_o);pcan_l28=pcan_v->pcan_l48;pcan_l34 pcan_z
;}pcan_l26 pcan_l113(1,&pcan_b->pcan_m.pcan_l.pcan_l78);pcan_l41(!
pcan_l120(&pcan_b->pcan_m.pcan_l.pcan_l46))pcan_l107();pcan_f(!pcan_v
->pcan_l48){ *pcan_l32=pcan_i.pcan_l126; *pcan_l38=pcan_i.pcan_l125; *
pcan_l80=pcan_i.pcan_l124; *pcan_l92=pcan_i.pcan_l102; *pcan_l77=
pcan_i.pcan_l122; *pcan_l99=pcan_i.pcan_l101; *pcan_l75=pcan_i.
pcan_l103; *pcan_l76=pcan_i.pcan_l119;}pcan_l28=pcan_v->pcan_l48;}
pcan_z:pcan_l84(&pcan_b->pcan_m.pcan_l.pcan_l46,0);pcan_q pcan_l28;}
pcan_l29 pcan_e pcan_l148(pcan_n pcan_p*pcan_b,pcan_l43 pcan_l98){
pcan_c pcan_a=0;pcan_c pcan_l32=(pcan_c)(pcan_l98&0xff);pcan_c
pcan_l38=(pcan_c)((pcan_l98>>8)&0xff);pcan_s(pcan_t"\x25\x73\x3a\x20"
"\x70\x63\x61\x6e\x5f\x68\x77\x5f\x73\x65\x74\x42\x54\x52\x30\x42\x54"
"\x52\x31\x28\x30\x78\x25\x30\x34\x78\x29\n",pcan_o,pcan_l98);pcan_q
pcan_l37(pcan_b,1,2,pcan_l32,pcan_l38,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}pcan_e
pcan_hw_SetCANOn(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;pcan_s(pcan_t""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53\x65\x74\x43\x41"
"\x4e\x4f\x6e\x28\x29\n",pcan_o);pcan_q pcan_l37(pcan_b,3,2,1,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a
,pcan_a,pcan_a);}pcan_e pcan_hw_SetCANOff(pcan_n pcan_p*pcan_b){
pcan_e pcan_g;pcan_c pcan_a=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63"
"\x61\x6e\x5f\x68\x77\x5f\x53\x65\x74\x43\x41\x4e\x4f\x66\x66\x28\x29"
"\n",pcan_o);pcan_g=pcan_l37(pcan_b,3,2,0,pcan_a,pcan_a,pcan_a,pcan_a
,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);
pcan_q pcan_g;}pcan_l29 pcan_e pcan_l159(pcan_n pcan_p*pcan_b){pcan_c
pcan_a=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77"
"\x5f\x53\x65\x74\x43\x41\x4e\x53\x69\x6c\x65\x6e\x74\x4f\x6e\x28\x29"
"\n",pcan_o);pcan_q pcan_l37(pcan_b,3,3,1,pcan_a,pcan_a,pcan_a,pcan_a
,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_l29 pcan_e pcan_l138(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;
pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53"
"\x65\x74\x43\x41\x4e\x53\x69\x6c\x65\x6e\x74\x4f\x66\x66\x28\x29\n",
pcan_o);pcan_q pcan_l37(pcan_b,3,3,0,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_e pcan_l199(pcan_n pcan_p*pcan_b,pcan_l43*pcan_l67){pcan_e pcan_g
;pcan_c pcan_a=0;pcan_c pcan_l32=0;pcan_c pcan_l38=0;pcan_s(pcan_t""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x42\x54"
"\x52\x30\x42\x54\x52\x31\x28\x29\n",pcan_o);pcan_g=pcan_l56(pcan_b,1
,1,&pcan_l32,&pcan_l38,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&
pcan_a); *pcan_l67=pcan_l38; *pcan_l67<<=8; *pcan_l67|=pcan_l32;
pcan_s(pcan_t"\x25\x73\x3a\x20\x42\x54\x52\x30\x42\x54\x52\x31\x20"
"\x3d\x20\x30\x78\x25\x30\x34\x78\n",pcan_o, *pcan_l67);pcan_q pcan_g
;}pcan_e pcan_l195(pcan_n pcan_p*pcan_b,pcan_l42*pcan_l85){pcan_e
pcan_g=0;pcan_c pcan_a=0;pcan_c pcan_l32=0;pcan_s(pcan_t"\x25\x73\x3a"
"\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x51\x75\x61\x72\x74"
"\x7a\x28\x29\n",pcan_o);pcan_g=pcan_l56(pcan_b,2,1,&pcan_l32,&pcan_a
,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a); *pcan_l85=pcan_l32
; *pcan_l85*=1000000L;pcan_s(pcan_t"\x25\x73\x3a\x20\x46\x72\x65\x71"
"\x75\x65\x6e\x7a\x20\x3d\x20\x25\x75\n",pcan_o, *pcan_l85);pcan_q
pcan_g;}pcan_e pcan_l189(pcan_n pcan_p*pcan_b,pcan_c pcan_l55,pcan_c
pcan_l27){pcan_e pcan_g=0;pcan_c pcan_a[8];pcan_e pcan_x;pcan_s(
pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74"
"\x41\x6e\x79\x74\x68\x69\x6e\x67\x28\x29\n",pcan_o);pcan_l123(pcan_x
=0;pcan_x<7;pcan_x++)pcan_a[pcan_x]=0;pcan_g=pcan_l56(pcan_b,pcan_l55
,pcan_l27,&pcan_a[0],&pcan_a[1],&pcan_a[2],&pcan_a[3],&pcan_a[4],&
pcan_a[5],&pcan_a[6],&pcan_a[7]);pcan_s(pcan_t"\x25\x73\x3a\x20\x46"
"\x75\x6e\x2f\x4e\x75\x6d\x3a\x25\x64\x2f\x25\x64\x20\x20\x30\x78\x25"
"\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78"
"\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78"
"\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32"
"\x78\n",pcan_o,pcan_l55,pcan_l27,pcan_a[0],pcan_a[1],pcan_a[2],
pcan_a[3],pcan_a[4],pcan_a[5],pcan_a[6],pcan_a[7]);pcan_q pcan_g;}
pcan_e pcan_l183(pcan_n pcan_p*pcan_b,pcan_c*pcan_l109){pcan_e pcan_g
;pcan_c pcan_a=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f"
"\x68\x77\x5f\x67\x65\x74\x44\x65\x76\x69\x63\x65\x4e\x72\x28\x29\n",
pcan_o);pcan_g=pcan_l56(pcan_b,4,1,pcan_l109,&pcan_a,&pcan_a,&pcan_a,
&pcan_a,&pcan_a,&pcan_a,&pcan_a);pcan_s(pcan_t"\x25\x73\x3a\x20\x44"
"\x65\x76\x69\x63\x65\x4e\x72\x20\x3d\x20\x30\x78\x25\x30\x32\x78\n",
pcan_o, *pcan_l109);pcan_q pcan_g;}pcan_e pcan_l179(pcan_n pcan_p*
pcan_b){pcan_c pcan_a=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61"
"\x6e\x5f\x68\x77\x5f\x53\x65\x74\x45\x78\x74\x56\x43\x43\x4f\x6e\x28"
"\x29\n",pcan_o);pcan_q pcan_l37(pcan_b,0xA,2,1,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a
);}pcan_e pcan_l170(pcan_n pcan_p*pcan_b,pcan_c pcan_l156){pcan_c
pcan_a=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77"
"\x5f\x53\x65\x74\x44\x65\x76\x69\x63\x65\x4e\x72\x28\x29\n",pcan_o);
pcan_q pcan_l37(pcan_b,4,2,pcan_l156,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_e pcan_l194(pcan_n pcan_p*pcan_b,pcan_l42 pcan_l66){pcan_c pcan_a
=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53"
"\x65\x74\x53\x4e\x52\x28\x29\n",pcan_o);pcan_q pcan_l37(pcan_b,6,2,(
pcan_c)(pcan_l66&0xff),(pcan_c)((pcan_l66>>8)&0xff),(pcan_c)((
pcan_l66>>16)&0xff),(pcan_c)((pcan_l66>>24)&0xff),pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}pcan_l29
pcan_e pcan_l145(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;pcan_s(pcan_t""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53\x65\x74\x45\x78"
"\x74\x56\x43\x43\x4f\x66\x66\x28\x29\n",pcan_o);pcan_q pcan_l37(
pcan_b,0xA,2,0,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}pcan_e pcan_hw_getSNR(
pcan_n pcan_p*pcan_b,pcan_l42*pcan_l64){pcan_e pcan_g;pcan_e pcan_x;
pcan_c pcan_l53[4];pcan_c pcan_a;pcan_s(pcan_t"\x25\x73\x3a\x20\x70"
"\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x53\x4e\x52\x28\x29\n",
pcan_o);pcan_g=pcan_l56(pcan_b,6,1,&pcan_l53[0],&pcan_l53[1],&
pcan_l53[2],&pcan_l53[3],&pcan_a,&pcan_a,&pcan_a,&pcan_a); *pcan_l64=
0;pcan_l123(pcan_x=3;pcan_x>=0;pcan_x--){ *pcan_l64<<=8; *pcan_l64|=
pcan_l53[pcan_x];}pcan_s(pcan_t"\x25\x73\x3a\x20\x53\x4e\x52\x20\x3d"
"\x20\x30\x78\x25\x30\x38\x78\n",pcan_o, *pcan_l64);pcan_q pcan_g;}
pcan_e pcan_hw_Init(pcan_n pcan_p*pcan_b,pcan_l43 pcan_l151,pcan_c
pcan_l127){pcan_e pcan_g=0;pcan_s(pcan_t"\x25\x73\x3a\x20\x70\x63\x61"
"\x6e\x5f\x68\x77\x5f\x49\x6e\x69\x74\x28\x29\n",pcan_o);pcan_g=
pcan_l148(pcan_b,pcan_l151);pcan_f(pcan_g)pcan_l34 pcan_z;pcan_f(
pcan_b->pcan_m.pcan_l.pcan_l114>3){pcan_f(pcan_l127)pcan_g=pcan_l159(
pcan_b);pcan_l26 pcan_g=pcan_l138(pcan_b);pcan_f(pcan_g)pcan_l34
pcan_z;}pcan_l26{pcan_f(pcan_l127){pcan_g=-pcan_l177;pcan_l34 pcan_z;
}}pcan_g=pcan_l145(pcan_b);pcan_l140(pcan_b);pcan_z:pcan_q pcan_g;}
pcan_e pcan_hw_X(pcan_n pcan_p*pcan_b,pcan_c*pcan_d,pcan_e pcan_l72){
pcan_e pcan_g=0;pcan_e pcan_x,pcan_l30;pcan_c pcan_l155;pcan_c
pcan_l112;pcan_c pcan_l36=0;pcan_c pcan_y;pcan_l142*pcan_u;pcan_l154
pcan_r;pcan_c*pcan_l79=pcan_d;pcan_e pcan_l117=0;pcan_c*pcan_l118=
pcan_d;pcan_c pcan_l121=0;pcan_f(!pcan_l72)pcan_q pcan_g;pcan_l155= *
pcan_d++;pcan_l112= *pcan_d++;pcan_l123(pcan_x=0;(pcan_x<pcan_l112);
pcan_x++){pcan_l116 pcan_k;pcan_l36= *pcan_d++;pcan_f(!(pcan_l36&0x40
)){pcan_g=pcan_l171(&pcan_b->pcan_l115,(pcan_l47* )&pcan_u);pcan_f(
pcan_g)pcan_l34 pcan_z;pcan_f(pcan_l36&0x10){pcan_u->pcan_l35.
pcan_l51=pcan_l169;pcan_y=0;}pcan_l26{pcan_u->pcan_l35.pcan_l51=
pcan_l172;pcan_y=pcan_l36&0x0F;pcan_f(pcan_y>8)pcan_y=8;}pcan_u->
pcan_l35.pcan_l106=pcan_y;pcan_f(pcan_l36&0x20){pcan_u->pcan_l35.
pcan_l51|=pcan_l161;
#ifdef __LITTLE_ENDIAN
pcan_k.pcan_j[0]= *pcan_d++;pcan_k.pcan_j[1]= *pcan_d++;pcan_k.pcan_j
[2]= *pcan_d++;pcan_k.pcan_j[3]= *pcan_d++;
#else
pcan_k.pcan_j[3]= *pcan_d++;pcan_k.pcan_j[2]= *pcan_d++;pcan_k.pcan_j
[1]= *pcan_d++;pcan_k.pcan_j[0]= *pcan_d++;
#endif
pcan_k.pcan_l40>>=3;}pcan_l26{pcan_k.pcan_l40=0;
#ifdef __LITTLE_ENDIAN
pcan_k.pcan_j[0]= *pcan_d++;pcan_k.pcan_j[1]= *pcan_d++;
#else
pcan_k.pcan_j[3]= *pcan_d++;pcan_k.pcan_j[2]= *pcan_d++;
#endif
pcan_k.pcan_l40>>=5;}pcan_u->pcan_l35.pcan_l147=pcan_k.pcan_l40;
pcan_f(!pcan_l121){
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_j[0]= *pcan_d++;pcan_r.pcan_j[1]= *pcan_d++;
#else
pcan_r.pcan_j[1]= *pcan_d++;pcan_r.pcan_j[0]= *pcan_d++;
#endif
pcan_l82(pcan_b,pcan_r.pcan_l95,pcan_x);}pcan_l26 pcan_l104(pcan_b, *
pcan_d++);pcan_u->pcan_l158=pcan_l129(pcan_b);pcan_l30=0;pcan_l41(
pcan_y--){pcan_u->pcan_l35.pcan_l81[pcan_l30]= *pcan_d++;pcan_l30++;}
pcan_f((!pcan_b->pcan_l184)&&(pcan_l36&0x20)){pcan_g=pcan_l200(&
pcan_b->pcan_l115);pcan_f(pcan_g)pcan_l34 pcan_z;}pcan_l26{pcan_g=
pcan_l180(&pcan_b->pcan_l115);pcan_f(pcan_g)pcan_l34 pcan_z;pcan_l117
++;}pcan_l121++;}pcan_l26{pcan_l142 pcan_l143;pcan_c pcan_l55;pcan_c
pcan_l27;pcan_c pcan_a;pcan_u=&pcan_l143;pcan_u->pcan_l35.pcan_l51=
pcan_l178;pcan_y=pcan_l36&0x0F;pcan_f(pcan_y>8)pcan_y=8;pcan_u->
pcan_l35.pcan_l106=pcan_y;pcan_l55= *pcan_d++;pcan_l27= *pcan_d++;
pcan_f(pcan_l36&0x80){pcan_f(!pcan_x){
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_j[0]= *pcan_d++;pcan_r.pcan_j[1]= *pcan_d++;
#else
pcan_r.pcan_j[1]= *pcan_d++;pcan_r.pcan_j[0]= *pcan_d++;
#endif
pcan_l82(pcan_b,pcan_r.pcan_l95,pcan_x);}pcan_l26 pcan_l104(pcan_b, *
pcan_d++);}pcan_l174(pcan_l55){pcan_l49 1:pcan_f((pcan_l27&0x02)||(
pcan_l27&0x40)){pcan_b->pcan_l74|=pcan_l188;pcan_b->pcan_l88++;}
pcan_f(pcan_l27&0x10){pcan_b->pcan_l74|=pcan_l182;pcan_b->pcan_l88++;
}pcan_f(pcan_l27&0x08){pcan_b->pcan_l74|=pcan_l202;pcan_b->pcan_l88++
;}pcan_f(pcan_l27&0x04)pcan_b->pcan_l74|=pcan_l198;pcan_l30=0;
pcan_l41(pcan_y--)pcan_u->pcan_l35.pcan_l81[pcan_l30++]= *pcan_d++;
pcan_l50;pcan_l49 2:pcan_a= *pcan_d++;pcan_a= *pcan_d++;pcan_l50;
pcan_l49 3:pcan_a= *pcan_d++;pcan_l50;pcan_l49 4:
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_j[0]= *pcan_d++;pcan_r.pcan_j[1]= *pcan_d++;
#else
pcan_r.pcan_j[1]= *pcan_d++;pcan_r.pcan_j[0]= *pcan_d++;
#endif
pcan_l82(pcan_b,pcan_r.pcan_l95,pcan_x);pcan_l50;pcan_l49 5:pcan_f(
pcan_l27&0x80){pcan_b->pcan_l74|=pcan_l190;pcan_b->pcan_l88++;}
pcan_l30=0;pcan_l41(pcan_y--)pcan_u->pcan_l35.pcan_l81[pcan_l30++]= *
pcan_d++;pcan_l50;pcan_l49 10:pcan_l50;pcan_l187:pcan_l97(pcan_l60""
"\x25\x73\x3a\x20\x75\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x66\x75"
"\x6e\x63\x74\x69\x6f\x6e\x2c\x20\x69\x20\x3d\x20\x25\x64\x2c\x20\x75"
"\x63\x53\x74\x61\x74\x75\x73\x4c\x65\x6e\x20\x3d\x20\x30\x78\x25\x30"
"\x32\x78\n",pcan_o,pcan_x,pcan_l36);pcan_l146(pcan_l118,4);}pcan_u->
pcan_l158=pcan_l129(pcan_b);}pcan_f((pcan_d-pcan_l79)>pcan_l72){
pcan_f((pcan_b->pcan_m.pcan_l.pcan_l114>3)||((pcan_b->pcan_m.pcan_l.
pcan_l114<=3)&&((pcan_d-pcan_l79)>(pcan_l72+1)))){pcan_g=-pcan_l196;
pcan_l97(pcan_l60"\x25\x73\x3a\x20\x49\x6e\x74\x65\x72\x6e\x61\x6c"
"\x20\x45\x72\x72\x6f\x72\x20\x3d\x20\x25\x64\x20\x28\x25\x64\x2c\x20"
"\x25\x64\x29\n",pcan_o,pcan_g,(pcan_d-pcan_l79),pcan_l72);pcan_l146(
pcan_l118,4);pcan_l34 pcan_z;}}}pcan_f(pcan_l117)pcan_l181(&pcan_b->
pcan_l176);pcan_z:pcan_q pcan_g;}pcan_e pcan_hw_Y(pcan_n pcan_p*
pcan_b,pcan_c*pcan_d,pcan_e*pcan_l71){pcan_e pcan_g=0;pcan_e pcan_l131
=0;pcan_c*pcan_w=pcan_d;pcan_c pcan_y;pcan_l116 pcan_k;pcan_c*
pcan_l68;pcan_c*pcan_l83;pcan_l175*pcan_u;pcan_e pcan_l30;pcan_c
pcan_l96=0;pcan_e pcan_l94= *pcan_l71;pcan_e pcan_l139=pcan_l94-14; *
pcan_l71=0; *pcan_w++=2;pcan_l83=pcan_w++;pcan_l41(!pcan_l96&&((
pcan_w-pcan_d)<pcan_l139)){pcan_f((pcan_g=pcan_l192(&pcan_b->
pcan_l130,(pcan_l47* )&pcan_u))){pcan_l96=1;pcan_s(pcan_t"\x25\x73"
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6c\x61\x69\x6d\x20\x77\x72"
"\x69\x74\x65\x46\x69\x66\x6f\x3a\x20\x25\x64\n",pcan_o,pcan_b->
pcan_l130.pcan_l185);}pcan_l26{pcan_l68=pcan_w++;pcan_y=pcan_u->
pcan_l106&0x0F; *pcan_l68=pcan_y;pcan_f(pcan_u->pcan_l51&pcan_l169) *
pcan_l68|=0x10;pcan_l30=0;pcan_k.pcan_l40=pcan_u->pcan_l147;pcan_f(
pcan_u->pcan_l51&pcan_l161){ *pcan_l68|=0x20;pcan_k.pcan_l40<<=3;
#ifdef __LITTLE_ENDIAN
 *pcan_w++=pcan_k.pcan_j[0]; *pcan_w++=pcan_k.pcan_j[1]; *pcan_w++=
pcan_k.pcan_j[2]; *pcan_w++=pcan_k.pcan_j[3];
#else
 *pcan_w++=pcan_k.pcan_j[3]; *pcan_w++=pcan_k.pcan_j[2]; *pcan_w++=
pcan_k.pcan_j[1]; *pcan_w++=pcan_k.pcan_j[0];
#endif
}pcan_l26{pcan_k.pcan_l40<<=5;
#ifdef __LITTLE_ENDIAN
 *pcan_w++=pcan_k.pcan_j[0]; *pcan_w++=pcan_k.pcan_j[1];
#else
 *pcan_w++=pcan_k.pcan_j[1]; *pcan_w++=pcan_k.pcan_j[0];
#endif
}pcan_l30=0;pcan_l41(pcan_y--){ *pcan_w++=pcan_u->pcan_l81[pcan_l30];
pcan_l30++;}pcan_l131++;pcan_f((pcan_g=pcan_l197(&pcan_b->pcan_l130)))pcan_l96
=1;}}pcan_f((pcan_w-pcan_d)>2){ *pcan_l71=pcan_l94;pcan_w=pcan_d+
pcan_l94-1; *pcan_w=(pcan_c)(pcan_b->pcan_m.pcan_l.pcan_l201++&0xff);
 *pcan_l83=pcan_l131;}pcan_l26{ *pcan_l71=0; *pcan_l83=0;}pcan_q
pcan_g;}
